
#include "stdafx.h"
#include "util.h"
#include "ArcManEXE.h"

void CArcManEXE::VersionString( CKString& VerStr )
{
	CKString Name;
	m_ModuleName.GetFileName( Name );
	char str[255];
	Name.Buf(str,12);
	memset( str+strlen(str),' ',13-strlen(str) );
	str[13]='\0';

	VerStr = str;
	VerStr += m_bAble ? "Found":"Not Found";
}

bool CArcManEXE::LoadFromNSE( const char* filename )
{
	FILE* fp = fopen(filename,"rt");
	if( fp==NULL )return false;

	char tmp[1024];
	CKString str[8];
	for( int i=1; i!=8; i++ )
	{
		if( NULL==fgets(tmp,sizeof(tmp),fp) )
		{
			fclose(fp);
			return false;
		}
		str[i]=tmp;
		str[i].RemoveWhiteSpace();
	}

	fclose(fp);

	Init( str[1] );

	char a[1024],b[1024],c[1024];
	if( *((const char*)str[2])!='\0' )
	{
		sscanf(str[2],"%[^ ,] , %[^ ,] , %[^\0]",a,b,c);
		AddCompressCmd(a,b,c);
	}
	if( *((const char*)str[3])!='\0' )
	{
		sscanf(str[3],"%[^ ,] , %[^ ,] , %[^\0]",a,b,c);
		AddCompressCmd(a,b,c);
	}
	if( *((const char*)str[4])!='\0' )
	{
		sscanf(str[4],"%[^ ,] , %[^ ,] , %[^\0]",a,b,c);
		AddCompressCmd(a,b,c);
	}
	if( *((const char*)str[5])!='\0' )
		SetSFXCmd( str[5] );
	if( *((const char*)str[6])!='\0' )
		SetMeltCmd( str[6] );
	if( *((const char*)str[7])!='\0' )
		m_ArcExt = str[7];

	return true;
}

void CArcManEXE::Init(const char* Exe)
{
	char find[MAX_PATH];
	m_bAble = ( 0!=SearchPath(NULL,Exe,".exe",sizeof(find),find,NULL) );

	m_ModuleName = Exe;
	if( m_bAble )
		m_ModuleName = find;
}

bool CArcManEXE::ExecCommand( const char* cmd , const char* current/*=NULL*/ )
{
	CKString Tmp;
	m_ModuleName.DoubleQuote(Tmp);	Tmp += " ";		Tmp += cmd;
	char* str = new char[Tmp.Length()+1];
	Tmp.Buf( str );

	PROCESS_INFORMATION pi;
	STARTUPINFO si;	memset(&si,0,sizeof(si));	si.cb = sizeof(si);
	BOOL ans = CreateProcess( NULL,str, NULL,NULL,FALSE,
									CREATE_NEW_PROCESS_GROUP|NORMAL_PRIORITY_CLASS,
										NULL,current,&si,&pi );
	delete [] str;

	DWORD code;
	while( GetExitCodeProcess( pi.hProcess , &code ) )
	{
		if( code!=STILL_ACTIVE )
		{
			if( code==0 )	ans = TRUE;
			else			ans = FALSE;
			break;
		}
	}

	CloseHandle( pi.hThread );
	CloseHandle( pi.hProcess );

	return ans!=0?true:false;
}

bool CArcManEXE::CanMelt( const char* fname )
{
	if( !m_bAble || m_MeltCmd.Length()==0 )
		return false;
	CKString File = fname;
	CKString Tmp,Ext;
	File.SplitPath( Tmp,Tmp,Ext );
	return Ext.Compare(m_ArcExt);
}
