
#include "stdafx.h"
#include "ArcManMS.h"
#include "util.h"

bool CArcManMS::CanMelt( const char* fname )
{
	char header[10]="SZDD'3A";
	FILE* fp = fopen(fname,"rt");
	if( fp==NULL )	return false;
	char f[9];
	fread(f,1,9,fp);
	fclose(fp);
	return ( memcmp(header,f,9)==0 );
}

bool CArcManMS::Melt( CKString& File,CKString* pPath,bool bMDir,bool bNoDDir )
{
	CKString Dir,Name,Ext,Tmp;
	OFSTRUCT of;
	of.cBytes = sizeof(of);

	if( bMDir )	
		*pPath+="noah_lz\\";

	char *fromname = new char[File.Length()+1];
	File.Buf( fromname );
	char expname[MAX_PATH];
	GetExpandedName( fromname,expname );
	Tmp = expname;
	Tmp.GetFileName( Name );

	CKString MotName=*pPath;
	CreateDir( MotName );
	MotName += Name;
	MotName.ToLowerCase();
	MotName.SplitPath( Dir,Name,Ext );

	// gqɕ⊮
		 if( Ext=="ex" )MotName+="e";
	else if( Ext=="co" )MotName+="m";
	else if( Ext=="sc" )MotName+="r";

	else if( Ext=="dl" )MotName+="l";
	else if( Ext=="oc" )MotName+="x";
	else if( Ext=="dr" )MotName+="v";
	else if( Ext=="38" )MotName+="6";
	else if( Ext=="sy" )MotName+="s";
	else if( Ext=="cp" )MotName+="l";
	else if( Ext=="li" )MotName+="b";
	else if( Ext=="tt" )MotName+="f";

	else if( Ext=="ch" )MotName+="m";
	else if( Ext=="hl" )MotName+="p";
	else if( Ext=="cn" )MotName+="t";
	else if( Ext=="da" )MotName+="t";

	else if( Ext=="tx" )MotName+="t";
	else if( Ext=="wr" )MotName+="i";
	else if( Ext=="wa" )MotName+="v";
	else if( Ext=="mi" )MotName+="d";
	else if( Ext=="bm" )MotName+="p";
	else if( Ext=="rl" )MotName+="e";

	char* toname = new char[MotName.Length()+2];
	MotName.Buf( toname );

	int FROM = LZOpenFile( fromname ,&of , OF_READ );
	int TO = LZOpenFile( toname ,&of , OF_WRITE|OF_CREATE );
	LZCopy( FROM , TO );
	LZClose( FROM );
	LZClose( TO );

	delete [] fromname;
	delete [] toname;
	return true;
}

void CArcManMS::VersionString( CKString& VerStr )
{
	VerStr="LzExpand.dll ";

	OSVERSIONINFO os;
	os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&os);
	switch(os.dwPlatformId)
	{
	case VER_PLATFORM_WIN32s:		VerStr+="Windows 3.1";	break;
	case VER_PLATFORM_WIN32_WINDOWS:
		if( os.dwMinorVersion==0 )	VerStr+="Windows 95";
		else						VerStr+="Windows 98";
		break;
	case VER_PLATFORM_WIN32_NT:
		{
			char nt[255];
			sprintf(nt,"Windows NT %d.%d",os.dwMajorVersion,os.dwMinorVersion);
			VerStr += nt;
		}
		break;
	}
}

