// util.cpp ƕ֗Ȋ֐̎

#include "stdafx.h"
#include "util.h"

bool CreateLink(const char* fname, const char* dstpath, const char* name) 
{
	HRESULT hr;
	CoInitialize(NULL);

	IShellLink* psl;
	hr = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&psl); 

	if( SUCCEEDED(hr) )
	{
		IPersistFile* ppf;
		char path[MAX_PATH];
		strcpy( path,fname );

		char* m=path;
		for( char* p=path; *p!='\0'; p=CharNext(p) )
		{
			if( *p=='\\' || *p=='/' )
				m=p;
		}
		*m='\0';

		psl->SetPath(fname);
		psl->SetDescription(name);
		psl->SetWorkingDirectory(path);
		
		hr = psl->QueryInterface(IID_IPersistFile,(void**)&ppf);
		
		if( SUCCEEDED(hr) )
		{
			WORD wsz[MAX_PATH]; 
			char lnkfile[MAX_PATH];
			strcpy(lnkfile, dstpath);
			strcat(lnkfile,"\\");
			strcat(lnkfile, name);
			strcat(lnkfile, ".lnk");
			
			MultiByteToWideChar(CP_ACP, 0, lnkfile, -1 , wsz, MAX_PATH);
			
			hr = ppf->Save(wsz,TRUE);
			ppf->Release();
		}
		psl->Release();
	}

	CoUninitialize();
	return SUCCEEDED(hr)?true:false;
}

bool GetSpecialDir( char* path,int nFolder,HWND hwnd/*=NULL*/ )
{
	if( nFolder==CSIDL_WINDOWS )	GetWindowsDirectory( path,MAX_PATH );
	else if( nFolder==CSIDL_SYSTEM ) GetSystemDirectory( path,MAX_PATH );
	else if( nFolder==CSIDL_TEMP )			GetTempPath( MAX_PATH,path );
	else if( nFolder==CSIDL_MODULE )
	{
		GetModuleFileName(NULL,path,MAX_PATH);

		char* m=path;
		for( char* p=path; *p!='\0'; p=CharNext(p) )
		{
			if( *p=='\\' || *p=='/' )
				m=p;
		}
		*m='\0';
	}
	else
	{
		LPITEMIDLIST pidl;
		if( NOERROR!=SHGetSpecialFolderLocation( hwnd , nFolder , &pidl ) )
			return false;
		if( !SHGetPathFromIDList(pidl,path) )
			return false;
	}

	char* m=path;
	for( char* p=path; *p!='\0'; p=CharNext(p) )
		m=p;
	if( *m=='\\' || *m=='/' )
		*m='\0';
	return true;
}

void CreateDir( const char* path )
{
	char s[MAX_PATH];
	strcpy( s,path );
	WIN32_FIND_DATA f;	HANDLE h;
	if( INVALID_HANDLE_VALUE!=(h=FindFirstFile( s,&f )) && (f.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) )
	{
		FindClose( h );
		return;
	}

	char *p = s;
	while( *p!='\0' )
	{
		if( *p=='\\' )
		{
			*p='\0';
			if( INVALID_HANDLE_VALUE==(h=FindFirstFile( s,&f )) ||
						!(f.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
				CreateDirectory(s,NULL);
			FindClose( h );
			*p='\\';
		}
		p=CharNext( p );
	}
}

void MsgLastError()
{
	char* pMsg;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL , GetLastError() , MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &pMsg , 0 , NULL );
	MessageBox( NULL,pMsg,"Error",MB_OK );
	LocalFree( pMsg );
}

bool MakeArg( int *argc , char ***argv , const char *cmd )
{
	int i,n;

	*argc=0;
	*argv=NULL;

	for( i=0; cmd[i]!='\0'; i++ )
	{
		if( cmd[i]!=' ' )
		{
			(*argc)++;
			char end = ( cmd[i]=='\"' ? '\"' : ' ');
			i++; while( cmd[i]!='\0' && cmd[i]!=end ) i++;
			if( cmd[i]=='\0' )
				break;
		}
	}

	if( *argc==0 )	return true;
	*argv = new char*[ *argc ];

	*argc=i=0;
	while( cmd[i]!='\0' )
	{
		if( cmd[i]=='\"' )
		{
			i++;
			if( cmd[i]=='\"' )
			{
				(*argv)[*argc] = new char[1];
				((*argv)[*argc])[0] = '\0';
				i++;
			}
			else
			{
				for( n=i+1; cmd[n]!='\0' && cmd[n]!='\"'; n++ );
				(*argv)[*argc] = new char[n-i+1];
				memcpy( (*argv)[*argc] , &cmd[i], n-i );
				((*argv)[(*argc)++])[n-i]='\0';
				i=n;
				if( cmd[n]!='\0' )i++;
			}
		}
		else if(cmd[i]!=' ')
		{
			for( n=i+1; cmd[n]!='\0' && cmd[n]!=' '; n++ );
			(*argv)[*argc] = new char[n-i+1];
			memcpy( (*argv)[*argc] , &cmd[i], n-i );
			((*argv)[(*argc)++])[n-i]='\0';
			i=n;
		}
		else
			i++;
	}
	return true;
}

void FreeArg( const int argc,char ***argv )
{
	for( int i=0; i<argc; i++ )
		delete [] ((*argv)[i]);
	delete [] (*argv);
}

void CenterWindow( HWND wnd , HWND parent )
{
	RECT rc;
	GetWindowRect(wnd,&rc);

	if( parent==NULL )
		SetWindowPos( wnd,0,(GetSystemMetrics(SM_CXSCREEN)-rc.right+rc.left)/2,
						(GetSystemMetrics(SM_CYSCREEN)-rc.bottom+rc.top)/2,0,0,SWP_NOSIZE|SWP_NOZORDER );
	else
	{
		RECT pr;
		GetWindowRect(parent,&pr);
		SetWindowPos( wnd,0,pr.left+(pr.right-pr.left-rc.right+rc.left)/2,
						pr.top+(pr.bottom-pr.top-rc.bottom+rc.top)/2,0,0,SWP_NOSIZE|SWP_NOZORDER );
	}
}

BOOL WritePrivateProfileInt( LPCTSTR lpAppName,LPCTSTR lpKeyName,INT value ,LPCTSTR lpFileName )
{
	char str[255];
	itoa(value,str,sizeof(str));
	return WritePrivateProfileString(lpAppName,lpKeyName,str,lpFileName);
}

static int CALLBACK KIOFProc( HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData )
{
	if( uMsg==BFFM_INITIALIZED && lpData!=NULL )
		SendMessage( hwnd , BFFM_SETSELECTION , TRUE , lpData );
	return 0;
}

bool OpenFolderDlg( char* pBuf , HWND parent , const char* pTitle , const char* pDefault )
{
	BROWSEINFO bi;
	memset( &bi,0,sizeof(bi) );
	bi.hwndOwner=parent;
	bi.pszDisplayName=pBuf;
	bi.lpszTitle=pTitle;
	bi.ulFlags=BIF_RETURNONLYFSDIRS|BIF_DONTGOBELOWDOMAIN;
	bi.lpfn = KIOFProc;
	if( pDefault!=NULL )
	{
		char tmp[MAX_PATH];
		strcpy( tmp,pDefault );
		int i=strlen(tmp)-1;
		if( tmp[i]=='\\' )
			tmp[i]='\0';
		bi.lParam = (long)tmp;
	}
	ITEMIDLIST* id = SHBrowseForFolder( &bi );
	if( id==NULL )
		return false;
	SHGetPathFromIDList( id,pBuf );
	int i=strlen(pBuf);
	if( pBuf[i-1]!='\\' )
		pBuf[i]='\\',pBuf[i+1]='\0';
	return true;
}

BOOL PathFileExists( const char* p )
{
	return (0xFFFFFFFF!=GetFileAttributes(p));
}

BOOL PathIsDirectory( const char* p )
{
	DWORD r = GetFileAttributes(p);
	if( r==0xFFFFFFFF )	return FALSE;
	return (r&FILE_ATTRIBUTE_DIRECTORY);
}


